#ifndef __VEC_MATH_H__
#define __VEC_MATH_H__

#include "lib/lib_defs.h"

typedef float t_elem;

class VEC {
public:
  VEC() {
    data[0] = data[1] = data[2] = 0;
  }
  VEC( t_elem a, t_elem b, t_elem c ) {
    data[0] = a;
    data[1] = b;
    data[2] = c;
  }
  VEC( t_elem* p ) {
    data[0] = *(p);
    data[1] = *(p+1);
    data[2] = *(p+2);
  }

  t_elem x() const	{ return data[0]; }
  t_elem y() const	{ return data[1]; }
  t_elem z() const	{ return data[2]; }

  t_elem x(t_elem d)	{ return data[0] = d; }
  t_elem y(t_elem d)	{ return data[1] = d; }
  t_elem z(t_elem d)	{ return data[2] = d; }

  t_elem size() const;
  void add( const VEC& a, const VEC& b );	// a+b
  void sub( const VEC& a, const VEC& b );	// a-b
  void smult( t_elem d );			// scalar multiply
  void normalize();
  void xprod( const VEC& a, const VEC& b );

  t_elem* vec3()	{ return data; }

  void print();

  t_elem& operator[]( int n );

  bool isZero()	{ 
    return (data[0]==0.0 && data[1]==0.0 && data[2]==0.0)?true:false; 
  }

  bool project_on( const VEC& a, const VEC& b );

protected:
  t_elem data[3];
};

t_elem dotprod( const VEC& a, const VEC& b );

#endif	// __VEC_MATH_H__
